0103abc

0103abc 的网站

= 算法、题解与学习记录 =

文章列表

题解

2025-02-25

356 字

鉴定为:【模板】最长上升子序列。 考虑到问题只和编号、体积两个状态有偏序关系,因此考虑对一个维度排序,然后对另一个维度求最长上升子序列。考虑到编号维的最值相对较小更容易处理,因此对体积从小到大排序,然后对编号维度跑 LIS 即可。直接做时间复杂度为 $O(n^2)$,考虑用 BIT...

题解

2025-02-25

344 字

比较巧妙的树上贪心。考虑在树上做 DFS,若当前结点为叶子结点则不做任何处理,否则,考虑一个非叶子结点 $u$,假设其所有儿子结点 $v1,v2,\ldots,vk$ 全部 DFS 处理过了,那么假设从当前结点到她们的儿子结点的距离分别为 $d1,d2,\ldots,dk$。则将 $d$...

题解

2025-02-25

503 字

直接暴力模拟时间复杂度为 $O(nml)$,显然过不去。因此考虑优化。发现若两个机器人移动到同一个位置,那么她们之后移动的状态也必然完全相同,可以合并,即只需要记录某一个位置是否存在机器人即可,不需要计数。因此考虑到用 bitset 优化,记录终止状态即只有 位置有机器人,所有机器人可在的位置集合...

题解

2025-02-24

1414 字

有一个很粤台晋的做法就是说直接暴力 $O(n^2)$ 建图,然后 $O(n^3)$ 跑 Floyd 求答案。看得出来没有什么前途。 考虑更聪明一些的做法。发现图十分特殊,$i,j$ 两个点有边当且仅当 $[li,ri]\cap[lj,rj]...

题解

2025-02-24

1117 字

好难。 遇事不决考虑先打表猜结论,手玩若干组小数据后可以发现下面的结论: 考虑建一张二分图。把 Alice 的点放在左边,Bob 的点放在右边,那么 Alice 必胜,当且仅当存在一个 Bob 的点,使得其和 Alice 所有的点都有连边,即其的度数为 $n$。 这个结论感觉很哇塞,于是考虑证明之。...

题解

2025-02-24

402 字

简单 $2300$。考虑到树的特殊性质,根节点到所有叶子结点的距离的奇偶性均相同,那么可以考虑把所有结点按照层数分类,问题转化为 Nim 阶梯博弈,只需要判断所有到所属子树内叶子结点距离为偶数的结点的异或值是否为 $0$ 即可。 问题变为如...

题解

2025-02-24

318 字

神秘的。直接做看上去十分困难,但是考虑到图中不能走出奇环,利用“二分图不存在奇环”这个性质,给图中每一个点随机赋值为 $0/1$,然后建图要求两个点权值不同才连边。此时不需要考虑奇环限制,暴力跑 dp 即可。因为一次算法正确率极低,而又不可能枚举所有的权值情况,因此考虑随机若干组数据(略大于...

题解

2025-02-24

416 字

考虑倒着 dp。设 $fi$ 表示从 $i$ 到 $n$ 最优策略下最多走多少步。考虑到若要保证从 $i$ 点走到 $j$ 点,那么需要先把所有比走到 $j$ 点更差的边全部断掉,才能保证从 $i$ 走到 $j$ 一定为最差情况。那么 dp 就是:初始条件为 $fn=0$,转移对于每一个...

题解

2025-02-24

418 字

笑点解析:不会 KMP 考虑一个简单的贪心:新建的串中能多放一个串 $t$ 就是一个串 $t$。于是可以得到 $O(n)$ 的解法,然后很高兴的获得 wa。 考虑做法为什么错了。发现每一次往新建串中放 $t$ 时,都可以去利用前面放过的 $t$。发现可以利用的长度就是 $t$ 中最大的 $l$ 满足...

题解

2025-02-24

374 字

首先有一个很简单的做法就是对所有坐标点做奇偶染色,然后奇数点放在 $A$ 集合偶数点放在 $B$ 集合。但是若 $A,B$ 集合中存在一个空集合就爆了。 然后可以考虑到调整坐标,若存在空集合就把所有点的横纵坐标都除以 $2$ 然后再来跑上面的算法,直到跑出来解为止。但是可以被样例 $2$ 给...

随机文章

加载中...